//---------------------------------------------  
#include "stdafx.h"                             
//--------------------------------------------- 
#include "Experiment03.h"                  
//--------------------------------------------- 
#include "Properties.h"                         
#include "GeoXOutput.h"
//--------------------------------------------- 
                                           
IMPLEMENT_GEOX_CLASS( Experiment03 ,0 )
{                                               
   BEGIN_CLASS_INIT( Experiment03 );       

	// add function button to GUI
	ADD_NOARGS_METHOD(Experiment03::drawOctagon)

	// add function button to GUI
	ADD_NOARGS_METHOD(Experiment03::resetPositions)
}

Experiment03::Experiment03()
{
	viewer = NULL;
	controlPointHandles.clear();
}

QWidget* Experiment03::createViewer()
{
	viewer = new GLGeometryViewer();
	return viewer;
}

void Experiment03::drawOctagon()
{
	// clear the viewer in any case
	// because it might be that it has been cleared form outside
	// this ensures that only one octagon is drawn at a time
	viewer->clear();
	controlPointHandles.clear();

	// create 8 control points as well as the
	// corresponding lines and add them to the viewer
	for(int i=0; i < 8; i++)
	{
		Point2D p;
		int pointHandle = viewer->addPoint(p);
		controlPointHandles.push_back(pointHandle);
	}
	// connect the points correctly
	for(int j=0; j < 8; j++)
	{
		Line l;
		l.vertices[0] = controlPointHandles[j];
		l.vertices[1] = controlPointHandles[(j+1) % 8];
		viewer->addLine(l);
	}

	// initialize the points with their appropriate positions
	this->resetPositions();
}

void Experiment03::resetPositions()
{
	// check if there are points to set anyway!
	if(!controlPointHandles.empty())
	{
		for(int i = 0; i < 8; i++)
		{
			// get information at requested position
			Point2D currentPoint = viewer->getPoint(controlPointHandles[i]);
			// change them
			currentPoint.position[0] = 5.0f*cos((M_PI/180.0f) * (22.5f+45.0f*i));
			currentPoint.position[1] = 5.0f*sin((M_PI/180.0f) * (22.5f+45.0f*i));
			// write them back
			viewer->setPoint(controlPointHandles[i],currentPoint);
		}
		// update changes
		viewer->refresh();
	}
}
